from django.db import IntegrityError
from django.http import JsonResponse



def serv_json(httpcode, code, msg, data=None):
    return JsonResponse({
        "code": code,
        "message": msg,
        "data": data
    }, status=httpcode)


def serv_json_ok(data=None, msg="Success"):
    return serv_json(200, 0, msg, data)


def serv_json_bad_request(data=None, msg="Bad Request"):
    return serv_json(400, 400, msg, data)


def serv_json_unauthorized(data=None, msg="Unauthorised"):
    return serv_json(401, 401, msg, data)


def serv_json_forbidden(data=None, msg="Forbidden"):
    return serv_json(403, 403, msg, data)

def serv_json_not_logged(data = None):
    msg = f"Vous devez vous logger pour effectuer cette action"
    if data:
        msg+=" : "+data
    return serv_json(401, 401, "Unauthorised", msg)



def serv_json_not_found(data=None, msg="Ressource not found"):
    return serv_json(404, 404, msg, data)


def serv_json_method_not_allowed(data=None, msg="Method Not Allowed"):
    return serv_json(405, 405, msg, data)


def serv_json_teapot(data=None, msg="I’m a teapot"):
    return serv_json(418, 418, msg, data)
