import datetime

import unidecode as unidecode


def parse_date(date):
    if isinstance(date, datetime.date):
        return date
    if isinstance(date, datetime.datetime):
        return date.date()
    if isinstance(date, (int, float)):
        return datetime.datetime.fromtimestamp(date).date()
    if isinstance(date, str):
        if date=="-":
            return None
        elif "-" in date and not "/" in date:
            return datetime.datetime.strptime(date, "%Y-%m-%d").date()
        elif "/" in date and not "-" in date:
            if date.index("/")>2:
                if len(date)==10:
                    return datetime.datetime.strptime(date, "%Y/%m/%d").date()
                elif len(date) == 8:
                    return datetime.datetime.strptime(date, "%Y/%m/%d").date()
            else:
                if len(date)==10:
                    return datetime.datetime.strptime(date, "%d/%m/%Y").date()
                elif len(date) == 8:
                    return datetime.datetime.strptime(date, "%d/%m/%y").date()
    return None

ALLOWED_CHARS = "ABCDEFGHIJKLMOPQRSTUVWXYZ 0123456789/-"

def simple_string(s, filter_chars=True):
    ret = unidecode.unidecode(s.upper())
    if filter_chars:
        return "".join([ x for x in ret if x in ALLOWED_CHARS])
    else:
        return ret