from djangotools.config.base import ConfigLoader
import os

settings = None
app_dir = None

def load_settings(module, base_dir=None, **kwargs):
    global settings
    global app_dir
    settings = module
    app_dir = ConfigLoader(module, base_dir, **kwargs)
    app_dir.init()
    return app_dir

loaded = False

def load_app(settings_module, app_dir=None, populate=True):
    global loaded
    if loaded: return
    loaded = True

    if app_dir:
        os.environ["APP_DIR"] = str(app_dir)

    if not "DJANGO_SETTINGS_MODULE" in os.environ:
        os.environ.setdefault('DJANGO_SETTINGS_MODULE', settings_module)

    from django.apps import apps
    from django.conf import settings

    if populate:
        apps.populate(settings.INSTALLED_APPS)