from collections import defaultdict

from django.apps import apps
from django.db.models.base import ModelBase, Model


def all_models(app=None):
    if app:
        return apps.all_models[app]
    return app.all_models


def iter_models(app=None):
    if app:
        return apps.all_models[app].values()
    for app, models in apps.all_models.items():
        for model in models.values():
            yield model

def iter_models_items(app=None):
    if app:
        return apps.all_models[app].items()
    for app, models in apps.all_models.items():
        for x in models.items():
            yield x

def get_model(name, app=None):
    name = name.lower()
    if isinstance(name, ModelBase):
        return name
    if app is not None: return apps.all_models[app][name]
    for _, models in apps.all_models.items():
        if name in models:
            return models[name]
    raise ValueError(f"Impossible de trouver le model {name}")